Index: uspace/lib/display/meson.build
===================================================================
--- uspace/lib/display/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/display/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,5 +27,5 @@
 #
 
-deps = [ 'gfx', 'ipcgfx' ]
+deps = [ 'gfx', 'ipcgfx', 'input' ]
 src = files(
 	'src/display.c',
Index: uspace/lib/display/private/params.h
===================================================================
--- uspace/lib/display/private/params.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/display/private/params.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -37,4 +37,5 @@
 
 #include <gfx/coord.h>
+#include <types/common.h>
 
 /** Window resize arguments. */
@@ -46,4 +47,23 @@
 } display_wnd_resize_t;
 
+/** Display window parameters encoded for transport
+ *
+ * This omits variable-length fields (window caption).
+ */
+typedef struct {
+	/** Bounding rectangle */
+	gfx_rect_t rect;
+	/** Window caption size in bytes */
+	size_t caption_size;
+	/** Minimum size (when being resized) */
+	gfx_coord2_t min_size;
+	/** Initial position (if flag wndf_setpos is set) */
+	gfx_coord2_t pos;
+	/** Flags */
+	display_wnd_flags_t flags;
+	/** Input device ID associated with window's seat (or zero) */
+	sysarg_t idev_id;
+} display_wnd_params_enc_t;
+
 #endif
 
Index: uspace/lib/display/src/disp_srv.c
===================================================================
--- uspace/lib/display/src/disp_srv.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/display/src/disp_srv.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -63,5 +63,7 @@
 	sysarg_t wnd_id;
 	ipc_call_t call;
+	display_wnd_params_enc_t eparams;
 	display_wnd_params_t params;
+	char *caption;
 	size_t size;
 	errno_t rc;
@@ -73,12 +75,40 @@
 	}
 
-	if (size != sizeof(display_wnd_params_t)) {
-		async_answer_0(&call, EINVAL);
-		async_answer_0(icall, EINVAL);
-		return;
-	}
-
-	rc = async_data_write_finalize(&call, &params, size);
-	if (rc != EOK) {
+	if (size != sizeof(display_wnd_params_enc_t)) {
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
+		return;
+	}
+
+	rc = async_data_write_finalize(&call, &eparams, size);
+	if (rc != EOK) {
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
+		return;
+	}
+
+	caption = calloc(eparams.caption_size + 1, 1);
+	if (caption == NULL) {
+		async_answer_0(icall, ENOMEM);
+		return;
+	}
+
+	if (!async_data_write_receive(&call, &size)) {
+		free(caption);
+		async_answer_0(&call, EREFUSED);
+		async_answer_0(icall, EREFUSED);
+		return;
+	}
+
+	if (size != eparams.caption_size) {
+		free(caption);
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
+		return;
+	}
+
+	rc = async_data_write_finalize(&call, caption, eparams.caption_size);
+	if (rc != EOK) {
+		free(caption);
 		async_answer_0(&call, rc);
 		async_answer_0(icall, rc);
@@ -87,7 +117,16 @@
 
 	if (srv->ops->window_create == NULL) {
-		async_answer_0(icall, ENOTSUP);
-		return;
-	}
+		free(caption);
+		async_answer_0(icall, ENOTSUP);
+		return;
+	}
+
+	/* Decode the parameters from transport */
+	params.rect = eparams.rect;
+	params.caption = caption;
+	params.min_size = eparams.min_size;
+	params.pos = eparams.pos;
+	params.flags = eparams.flags;
+	params.idev_id = eparams.idev_id;
 
 	rc = srv->ops->window_create(srv->arg, &params, &wnd_id);
@@ -114,4 +153,5 @@
 {
 	sysarg_t wnd_id;
+	sysarg_t pos_id;
 	ipc_call_t call;
 	gfx_coord2_t pos;
@@ -120,4 +160,5 @@
 
 	wnd_id = ipc_get_arg1(icall);
+	pos_id = ipc_get_arg2(icall);
 
 	if (!async_data_write_receive(&call, &size)) {
@@ -145,5 +186,5 @@
 	}
 
-	rc = srv->ops->window_move_req(srv->arg, wnd_id, &pos);
+	rc = srv->ops->window_move_req(srv->arg, wnd_id, &pos, pos_id);
 	async_answer_0(icall, rc);
 }
@@ -203,4 +244,5 @@
 
 	if (!async_data_read_receive(&call, &size)) {
+		async_answer_0(&call, EREFUSED);
 		async_answer_0(icall, EREFUSED);
 		return;
@@ -221,4 +263,49 @@
 
 	rc = async_data_read_finalize(&call, &dpos, size);
+	if (rc != EOK) {
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
+		return;
+	}
+
+	async_answer_0(icall, EOK);
+}
+
+static void display_window_get_max_rect_srv(display_srv_t *srv,
+    ipc_call_t *icall)
+{
+	sysarg_t wnd_id;
+	ipc_call_t call;
+	gfx_rect_t rect;
+	size_t size;
+	errno_t rc;
+
+	wnd_id = ipc_get_arg1(icall);
+
+	if (srv->ops->window_get_max_rect == NULL) {
+		async_answer_0(icall, ENOTSUP);
+		return;
+	}
+
+	if (!async_data_read_receive(&call, &size)) {
+		async_answer_0(&call, EREFUSED);
+		async_answer_0(icall, EREFUSED);
+		return;
+	}
+
+	rc = srv->ops->window_get_max_rect(srv->arg, wnd_id, &rect);
+	if (rc != EOK) {
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
+		return;
+	}
+
+	if (size != sizeof(gfx_rect_t)) {
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
+		return;
+	}
+
+	rc = async_data_read_finalize(&call, &rect, size);
 	if (rc != EOK) {
 		async_answer_0(&call, rc);
@@ -236,4 +323,5 @@
 	display_wnd_rsztype_t rsztype;
 	gfx_coord2_t pos;
+	sysarg_t pos_id;
 	size_t size;
 	errno_t rc;
@@ -241,4 +329,5 @@
 	wnd_id = ipc_get_arg1(icall);
 	rsztype = (display_wnd_rsztype_t) ipc_get_arg2(icall);
+	pos_id = ipc_get_arg3(icall);
 
 	if (!async_data_write_receive(&call, &size)) {
@@ -266,5 +355,6 @@
 	}
 
-	rc = srv->ops->window_resize_req(srv->arg, wnd_id, rsztype, &pos);
+	rc = srv->ops->window_resize_req(srv->arg, wnd_id, rsztype, &pos,
+	    pos_id);
 	async_answer_0(icall, rc);
 }
@@ -309,4 +399,52 @@
 }
 
+static void display_window_minimize_srv(display_srv_t *srv, ipc_call_t *icall)
+{
+	sysarg_t wnd_id;
+	errno_t rc;
+
+	wnd_id = ipc_get_arg1(icall);
+
+	if (srv->ops->window_minimize == NULL) {
+		async_answer_0(icall, ENOTSUP);
+		return;
+	}
+
+	rc = srv->ops->window_minimize(srv->arg, wnd_id);
+	async_answer_0(icall, rc);
+}
+
+static void display_window_maximize_srv(display_srv_t *srv, ipc_call_t *icall)
+{
+	sysarg_t wnd_id;
+	errno_t rc;
+
+	wnd_id = ipc_get_arg1(icall);
+
+	if (srv->ops->window_maximize == NULL) {
+		async_answer_0(icall, ENOTSUP);
+		return;
+	}
+
+	rc = srv->ops->window_maximize(srv->arg, wnd_id);
+	async_answer_0(icall, rc);
+}
+
+static void display_window_unmaximize_srv(display_srv_t *srv, ipc_call_t *icall)
+{
+	sysarg_t wnd_id;
+	errno_t rc;
+
+	wnd_id = ipc_get_arg1(icall);
+
+	if (srv->ops->window_unmaximize == NULL) {
+		async_answer_0(icall, ENOTSUP);
+		return;
+	}
+
+	rc = srv->ops->window_unmaximize(srv->arg, wnd_id);
+	async_answer_0(icall, rc);
+}
+
 static void display_window_set_cursor_srv(display_srv_t *srv, ipc_call_t *icall)
 {
@@ -325,4 +463,47 @@
 	rc = srv->ops->window_set_cursor(srv->arg, wnd_id, cursor);
 	async_answer_0(icall, rc);
+}
+
+static void display_window_set_caption_srv(display_srv_t *srv,
+    ipc_call_t *icall)
+{
+	sysarg_t wnd_id;
+	ipc_call_t call;
+	char *caption;
+	size_t size;
+	errno_t rc;
+
+	wnd_id = ipc_get_arg1(icall);
+
+	if (!async_data_write_receive(&call, &size)) {
+		async_answer_0(&call, EREFUSED);
+		async_answer_0(icall, EREFUSED);
+		return;
+	}
+
+	caption = calloc(size + 1, 1);
+	if (caption == NULL) {
+		async_answer_0(&call, ENOMEM);
+		async_answer_0(icall, ENOMEM);
+		return;
+	}
+
+	rc = async_data_write_finalize(&call, caption, size);
+	if (rc != EOK) {
+		free(caption);
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
+		return;
+	}
+
+	if (srv->ops->window_set_caption == NULL) {
+		free(caption);
+		async_answer_0(icall, ENOTSUP);
+		return;
+	}
+
+	rc = srv->ops->window_set_caption(srv->arg, wnd_id, caption);
+	async_answer_0(icall, rc);
+	free(caption);
 }
 
@@ -348,4 +529,5 @@
 	/* Transfer event data */
 	if (!async_data_read_receive(&call, &size)) {
+		async_answer_0(&call, EREFUSED);
 		async_answer_0(icall, EREFUSED);
 		return;
@@ -382,4 +564,5 @@
 	/* Transfer information */
 	if (!async_data_read_receive(&call, &size)) {
+		async_answer_0(&call, EREFUSED);
 		async_answer_0(icall, EREFUSED);
 		return;
@@ -445,4 +628,7 @@
 			display_window_get_pos_srv(srv, &call);
 			break;
+		case DISPLAY_WINDOW_GET_MAX_RECT:
+			display_window_get_max_rect_srv(srv, &call);
+			break;
 		case DISPLAY_WINDOW_RESIZE_REQ:
 			display_window_resize_req_srv(srv, &call);
@@ -451,6 +637,18 @@
 			display_window_resize_srv(srv, &call);
 			break;
+		case DISPLAY_WINDOW_MINIMIZE:
+			display_window_minimize_srv(srv, &call);
+			break;
+		case DISPLAY_WINDOW_MAXIMIZE:
+			display_window_maximize_srv(srv, &call);
+			break;
+		case DISPLAY_WINDOW_UNMAXIMIZE:
+			display_window_unmaximize_srv(srv, &call);
+			break;
 		case DISPLAY_WINDOW_SET_CURSOR:
 			display_window_set_cursor_srv(srv, &call);
+			break;
+		case DISPLAY_WINDOW_SET_CAPTION:
+			display_window_set_caption_srv(srv, &call);
 			break;
 		case DISPLAY_GET_EVENT:
Index: uspace/lib/display/src/display.c
===================================================================
--- uspace/lib/display/src/display.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/display/src/display.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,4 +38,5 @@
 #include <mem.h>
 #include <stdlib.h>
+#include <str.h>
 #include "../private/display.h"
 #include "../private/params.h"
@@ -68,5 +69,5 @@
 		dsname = SERVICE_NAME_DISPLAY;
 
-	rc = loc_service_get_id(dsname, &display_svc, IPC_FLAG_BLOCKING);
+	rc = loc_service_get_id(dsname, &display_svc, 0);
 	if (rc != EOK) {
 		free(display);
@@ -75,5 +76,5 @@
 
 	display->sess = loc_service_connect(display_svc, INTERFACE_DISPLAY,
-	    IPC_FLAG_BLOCKING);
+	    0);
 	if (display->sess == NULL) {
 		free(display);
@@ -147,4 +148,5 @@
 {
 	memset(params, 0, sizeof(*params));
+	params->caption = "";
 }
 
@@ -162,8 +164,17 @@
 {
 	display_window_t *window;
-	async_exch_t *exch;
-	aid_t req;
-	ipc_call_t answer;
-	errno_t rc;
+	display_wnd_params_enc_t eparams;
+	async_exch_t *exch;
+	aid_t req;
+	ipc_call_t answer;
+	errno_t rc;
+
+	/* Encode the parameters for transport */
+	eparams.rect = params->rect;
+	eparams.caption_size = str_size(params->caption);
+	eparams.min_size = params->min_size;
+	eparams.pos = params->pos;
+	eparams.flags = params->flags;
+	eparams.idev_id = params->idev_id;
 
 	window = calloc(1, sizeof(display_window_t));
@@ -173,5 +184,18 @@
 	exch = async_exchange_begin(display->sess);
 	req = async_send_0(exch, DISPLAY_WINDOW_CREATE, &answer);
-	rc = async_data_write_start(exch, params, sizeof (display_wnd_params_t));
+
+	/* Write fixed fields */
+	rc = async_data_write_start(exch, &eparams,
+	    sizeof (display_wnd_params_enc_t));
+	if (rc != EOK) {
+		async_exchange_end(exch);
+		async_forget(req);
+		free(window);
+		return rc;
+	}
+
+	/* Write caption */
+	rc = async_data_write_start(exch, params->caption,
+	    eparams.caption_size);
 	async_exchange_end(exch);
 	if (rc != EOK) {
@@ -261,15 +285,18 @@
  * @param window Window
  * @param pos Position in the window where the button was pressed
- * @return EOK on success or an error code
- */
-errno_t display_window_move_req(display_window_t *window, gfx_coord2_t *pos)
-{
-	async_exch_t *exch;
-	aid_t req;
-	ipc_call_t answer;
-	errno_t rc;
-
-	exch = async_exchange_begin(window->display->sess);
-	req = async_send_1(exch, DISPLAY_WINDOW_MOVE_REQ, window->id, &answer);
+ * @param pos_id Positioning device ID
+ * @return EOK on success or an error code
+ */
+errno_t display_window_move_req(display_window_t *window, gfx_coord2_t *pos,
+    sysarg_t pos_id)
+{
+	async_exch_t *exch;
+	aid_t req;
+	ipc_call_t answer;
+	errno_t rc;
+
+	exch = async_exchange_begin(window->display->sess);
+	req = async_send_2(exch, DISPLAY_WINDOW_MOVE_REQ, window->id,
+	    pos_id, &answer);
 	rc = async_data_write_start(exch, (void *)pos, sizeof (gfx_coord2_t));
 	async_exchange_end(exch);
@@ -350,4 +377,36 @@
 }
 
+/** Get display window maximized rectangle.
+ *
+ * Get the rectangle to which a window would be maximized.
+ *
+ * @param window Window
+ * @param rect Place to store maximized rectangle
+ * @return EOK on success or an error code
+ */
+errno_t display_window_get_max_rect(display_window_t *window, gfx_rect_t *rect)
+{
+	async_exch_t *exch;
+	aid_t req;
+	ipc_call_t answer;
+	errno_t rc;
+
+	exch = async_exchange_begin(window->display->sess);
+	req = async_send_1(exch, DISPLAY_WINDOW_GET_MAX_RECT, window->id,
+	    &answer);
+	rc = async_data_read_start(exch, rect, sizeof (gfx_rect_t));
+	async_exchange_end(exch);
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+
+	async_wait_for(req, &rc);
+	if (rc != EOK)
+		return rc;
+
+	return EOK;
+}
+
 /** Request a window resize.
  *
@@ -359,17 +418,18 @@
  * @param rsztype Resize type (which part of window frame is being dragged)
  * @param pos Position in the window where the button was pressed
+ * @param pos_id Positioning device ID
  * @return EOK on success or an error code
  */
 errno_t display_window_resize_req(display_window_t *window,
-    display_wnd_rsztype_t rsztype, gfx_coord2_t *pos)
-{
-	async_exch_t *exch;
-	aid_t req;
-	ipc_call_t answer;
-	errno_t rc;
-
-	exch = async_exchange_begin(window->display->sess);
-	req = async_send_2(exch, DISPLAY_WINDOW_RESIZE_REQ, window->id,
-	    (sysarg_t) rsztype, &answer);
+    display_wnd_rsztype_t rsztype, gfx_coord2_t *pos, sysarg_t pos_id)
+{
+	async_exch_t *exch;
+	aid_t req;
+	ipc_call_t answer;
+	errno_t rc;
+
+	exch = async_exchange_begin(window->display->sess);
+	req = async_send_3(exch, DISPLAY_WINDOW_RESIZE_REQ, window->id,
+	    (sysarg_t) rsztype, pos_id, &answer);
 	rc = async_data_write_start(exch, (void *)pos, sizeof (gfx_coord2_t));
 	async_exchange_end(exch);
@@ -455,4 +515,55 @@
 }
 
+/** Minimize window.
+ *
+ * @param window Window
+ * @return EOK on success or an error code
+ */
+errno_t display_window_minimize(display_window_t *window)
+{
+	async_exch_t *exch;
+	errno_t rc;
+
+	exch = async_exchange_begin(window->display->sess);
+	rc = async_req_1_0(exch, DISPLAY_WINDOW_MINIMIZE, window->id);
+	async_exchange_end(exch);
+
+	return rc;
+}
+
+/** Maximize window.
+ *
+ * @param window Window
+ * @return EOK on success or an error code
+ */
+errno_t display_window_maximize(display_window_t *window)
+{
+	async_exch_t *exch;
+	errno_t rc;
+
+	exch = async_exchange_begin(window->display->sess);
+	rc = async_req_1_0(exch, DISPLAY_WINDOW_MAXIMIZE, window->id);
+	async_exchange_end(exch);
+
+	return rc;
+}
+
+/** Unmaximize window.
+ *
+ * @param window Window
+ * @return EOK on success or an error code
+ */
+errno_t display_window_unmaximize(display_window_t *window)
+{
+	async_exch_t *exch;
+	errno_t rc;
+
+	exch = async_exchange_begin(window->display->sess);
+	rc = async_req_1_0(exch, DISPLAY_WINDOW_UNMAXIMIZE, window->id);
+	async_exchange_end(exch);
+
+	return rc;
+}
+
 /** Set window cursor.
  *
@@ -474,4 +585,37 @@
 	    cursor);
 	async_exchange_end(exch);
+	return rc;
+}
+
+/** Set display window caption.
+ *
+ * @param window Window
+ * @param caption New caption
+ * @return EOK on success or an error code
+ */
+errno_t display_window_set_caption(display_window_t *window,
+    const char *caption)
+{
+	async_exch_t *exch;
+	aid_t req;
+	ipc_call_t answer;
+	size_t cap_size;
+	errno_t rc;
+
+	cap_size = str_size(caption);
+
+	exch = async_exchange_begin(window->display->sess);
+	req = async_send_1(exch, DISPLAY_WINDOW_SET_CAPTION, window->id,
+	    &answer);
+
+	/* Write caption */
+	rc = async_data_write_start(exch, caption, cap_size);
+	async_exchange_end(exch);
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+
+	async_wait_for(req, &rc);
 	return rc;
 }
@@ -577,5 +721,6 @@
 		case wev_focus:
 			if (window->cb != NULL && window->cb->focus_event != NULL) {
-				window->cb->focus_event(window->cb_arg);
+				window->cb->focus_event(window->cb_arg,
+				    event.ev.focus.nfocus);
 			}
 			break;
@@ -600,5 +745,6 @@
 		case wev_unfocus:
 			if (window->cb != NULL && window->cb->unfocus_event != NULL) {
-				window->cb->unfocus_event(window->cb_arg);
+				window->cb->unfocus_event(window->cb_arg,
+				    event.ev.unfocus.nfocus);
 			}
 			break;
